#include <Arduino.h>
#include "HeadOutputMessage.h"
#include <SimpleSerialization.h>
const int trigPinL = 2;
const int echoPinL = 3;
const int trigPinC = 4;
const int echoPinC = 5;
const int trigPinR = 6;
const int echoPinR = 7;
const int trigPin0 = 8;
const int echoPin0 = 9;
const int trigPin18 = 10;
const int echoPin18 = 11;
const unsigned long mesureInterferenceDelay = 10;
const unsigned long timeout = 10000;
HeadOutputMessage hom;
long duration;
int distance;

void setup() {
  SimpleSerialization.begin(&Serial, 115200);
  pinMode(trigPinL, OUTPUT);
  pinMode(echoPinL, INPUT);
  pinMode(trigPinC, OUTPUT);
  pinMode(echoPinC, INPUT);
  pinMode(trigPinR, OUTPUT);
  pinMode(echoPinR, INPUT);
  pinMode(trigPin0, OUTPUT);
  pinMode(echoPin0, INPUT);
  pinMode(trigPin18, OUTPUT);
  pinMode(echoPin18, INPUT);
}

int calculateDistance(int trigPin, int echoPin){ 
  
  digitalWrite(trigPin, LOW); 
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH); 
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH, timeout);
  distance= duration*0.034/2;
  return distance;
}

void loop() {
  //delay(30)
  // 0 45 90 135 180
  //   50 90 140 

  hom.setUltrasonic(calculateDistance(trigPin0, echoPin0));
  hom.setServo(0);
  SimpleSerialization.write(&hom);
  delay(mesureInterferenceDelay);

  hom.setUltrasonic(calculateDistance(trigPinL, echoPinL));
  hom.setServo(50);
  SimpleSerialization.write(&hom);
  delay(mesureInterferenceDelay);
  hom.setUltrasonic(calculateDistance(trigPinC, echoPinC));
  hom.setServo(90);
  SimpleSerialization.write(&hom);
  delay(mesureInterferenceDelay);
  hom.setUltrasonic(calculateDistance(trigPinR, echoPinR));
  hom.setServo(140);
  SimpleSerialization.write(&hom);
  delay(mesureInterferenceDelay);
  
  hom.setUltrasonic(calculateDistance(trigPin18, echoPin18));
  hom.setServo(180);
  SimpleSerialization.write(&hom);
  delay(mesureInterferenceDelay);
  
}
