#include <Arduino.h>
#include <SimpleSerialization.h>

#include "MPU9250.h"
#include "MagGpsMessage.h"
#include "ImuMessage.h"
#include "KvIntMessage.h"
#include "KvByteMessage.h"
#include "KvFloatMessage.h"
#include "MagGpsInputMessage.h"
#include "constants.h"
#include "Message.h"
#include "Servo.h"

#include <Wire.h>
#include "compass.h"

//IMU
//MPU9250 IMU(Wire,0x68);

//SERVO
Servo tiltServo;
Servo panServo;
int tiltServoPin = 10;
int panServoPin = 11;

//MSG
ImuMessage imuMessage;
KvByteMessage calib;
KvIntMessage measureDelay;
KvFloatMessage offset;
KvFloatMessage offsetOut;
Message rfid;
char buffer[13];
int pointer = 0;

//LED
int calibLed = 8;

void kalibrace(){
  compass_debug = 1;
  compass_offset_calibration(3);
}

int calibMag(){
  digitalWrite(calibLed, HIGH);
    //int state = IMU.calibrateMag();
    int state = 1;
    kalibrace();
    digitalWrite(calibLed, LOW);
    delay(500);
    if(state>0){
      digitalWrite(calibLed, HIGH);
      delay(500);
      digitalWrite(calibLed, LOW);
    }else{
      digitalWrite(calibLed, HIGH);
      delay(300);
      digitalWrite(calibLed, LOW);
      delay(300);
      digitalWrite(calibLed, HIGH);
      delay(300);
      digitalWrite(calibLed, LOW);
      delay(300);
      digitalWrite(calibLed, HIGH);
      delay(300);
      digitalWrite(calibLed, LOW);
    }
    return state;
}

void kvFfloat(){
      digitalWrite(calibLed, HIGH);
      delay(500);
      digitalWrite(calibLed, LOW);
  switch (offset.getKey())
  {
  case 1:
    if(offset.getMode()==0){compass_x_offset = offset.getValue();}
    if(offset.getMode()==1){offset.setValue(compass_x_offset);}
    break;
  case 2:
    if(offset.getMode()==0){compass_y_offset = offset.getValue();}
    if(offset.getMode()==1){offset.setValue(compass_y_offset);}
    break;
  case 3:
    if(offset.getMode()==0){compass_z_offset = offset.getValue();}
    if(offset.getMode()==1){offset.setValue(compass_z_offset);}  
    break;  
  case 4:
    if(offset.getMode()==0){compass_x_gainError = offset.getValue();}
    if(offset.getMode()==1){offset.setValue(compass_x_gainError);}  
    break; 
  case 5:
    if(offset.getMode()==0){compass_y_gainError = offset.getValue();}
    if(offset.getMode()==1){offset.setValue(compass_y_gainError);}  
    break;
  case 6:
    if(offset.getMode()==0){compass_z_gainError = offset.getValue();}
    if(offset.getMode()==1){offset.setValue(compass_z_gainError);}  
    break;
  case 7:
    if(offset.getMode()==1){offset.setValue(calibMag());};
    break;
  case 8:
    if(offset.getMode()==0){tiltServo.write(offset.getValue());}
    if(offset.getMode()==1){offset.setValue(tiltServo.read());}  
    break;
  case 9:
    if(offset.getMode()==0){panServo.write(offset.getValue());}
    if(offset.getMode()==1){offset.setValue(panServo.read());}
    break;
  default:
    break;
  }
  if(offset.getMode()==1){
    offset.setMode(3);
    digitalWrite(calibLed, HIGH);
      delay(100);
      digitalWrite(calibLed, LOW);
      delay(100);
      digitalWrite(calibLed, HIGH);
      delay(100);
      digitalWrite(calibLed, LOW);
      offsetOut.setKey(offset.getKey());
      offsetOut.setMode(offset.getMode());
      offsetOut.setValue(offset.getValue());
    SimpleSerialization.write(&offsetOut);
  }
}

void setImu(){
    compass_heading();
  //IMU.readSensor();
  /*
  imuMessage.setAccX(IMU.getAccelX_mss());
  imuMessage.setAccY(IMU.getAccelY_mss());
  imuMessage.setAccZ(IMU.getAccelZ_mss());

  imuMessage.setGyrX(IMU.getGyroX_rads());
  imuMessage.setGyrY(IMU.getGyroY_rads());
  imuMessage.setGyrZ(IMU.getGyroZ_rads());

  imuMessage.setMagX(IMU.getMagX_uT());
  imuMessage.setMagY(IMU.getMagY_uT());
  imuMessage.setMagZ(IMU.getMagZ_uT());
  */
 imuMessage.setMagX(bearing);

  //mgm.setMagX(3.14281828);
  //mgm.setMagY(32.323232);
  //mgm.setMagZ(64.646464);
}

void setup() {
  pinMode(tiltServoPin, OUTPUT);
  pinMode(panServoPin, OUTPUT);
  tiltServo.attach(tiltServoPin);
  panServo.attach(panServoPin);
  tiltServo.write(90);
  panServo.write(90);
  Wire.begin();
  compass_init(2);
  Serial1.begin(9600);
  imuMessage.setPreamble(4294901761);
  imuMessage.setPostamble(4294901762);
  calib.setPreamble(4294901763);
  calib.setPostamble(4294901764);
  measureDelay.setPreamble(4294901765);
  measureDelay.setPostamble(4294901766);
  measureDelay.setValue(100);
  rfid.setPreamble(4294901767);
  rfid.setPostamble(4294901768);
  offset.setPreamble(4294901769);
  offset.setPostamble(4294901770);
  offsetOut.setPreamble(4294901769);
  offsetOut.setPostamble(4294901770);
  //IMU.begin();
    // setting the accelerometer full scale range to +/-8G 
  //IMU.setAccelRange(MPU9250::ACCEL_RANGE_8G);
  // setting the gyroscope full scale range to +/-500 deg/s
  //IMU.setGyroRange(MPU9250::GYRO_RANGE_500DPS);
  // setting DLPF bandwidth to 20 Hz
  //IMU.setDlpfBandwidth(MPU9250::DLPF_BANDWIDTH_20HZ);
  // setting SRD to 19 for a 50 Hz update rate
  //IMU.setSrd(19);
  pinMode(calibLed, OUTPUT);
  digitalWrite(calibLed, LOW);
  offset.setUpdateCallback(&kvFfloat);
  SimpleSerialization.begin(&Serial2,115200);
  SimpleSerialization.addDeserializableData(&offset);
  SimpleSerialization.addDeserializableData(&measureDelay);
}

void loop() {
  while(Serial2.available()>0){
    digitalWrite(calibLed, HIGH);
    digitalWrite(calibLed, LOW);
    SimpleSerialization.processInput();
  }
  /*
  if(Serial1.available()>12){
    for(pointer=0;pointer<14;pointer++){
      buffer[pointer] = Serial1.read();
    }
    rfid.setMessage(buffer);
    SimpleSerialization.write(&rfid);
    while (Serial1.available()){Serial1.read();}
  }
  */
  setImu();
  SimpleSerialization.write(&imuMessage);

  delay(measureDelay.getValue());
}