/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "BridgeMessage.h"

int BridgeMessage::getDataSize() {
  return 4;
}

void BridgeMessage::readData(SerializationInputStream& input) {
  mode = input.readByte();
  left = input.readByte();
  right = input.readByte();
  enable = input.readByte();
}

void BridgeMessage::writeData(SerializationOutputStream& output) {
  output.writeByte(mode);
  output.writeByte(left);
  output.writeByte(right);
  output.writeByte(enable);
}

