/*
 * This is the declaration of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#ifndef _BRIDGEMESSAGE_H
#define	_BRIDGEMESSAGE_H

#include "SimpleSerialization.h"

class BridgeMessage : public SerializationData {
public:
    int getDataSize();
    void readData(SerializationInputStream& input);
    void writeData(SerializationOutputStream& output);
    byte getMode(){return mode;};
    byte getLeft(){return left;};
    byte getRight(){return right;};
    byte getEnable(){return enable;};
    void setMode(byte mode){this->mode = mode;};
    void setLeft(byte left){this->left = left;};
    void setRight(byte right){this->right = right;};
    void setEnable(byte enable){this->enable = enable;};
private:
    byte mode;
    byte left;
    byte right;
    byte enable;
};

#endif	/* _BRIDGEMESSAGE_H */
