/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "EnginesControllerMessage.h"

int EnginesControllerMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*2+2;
}

void EnginesControllerMessage::readData(SerializationInputStream& input) {
  left = input.readFloat();
  right = input.readFloat();
  mode = input.readByte();
  enable = input.readByte();
}

void EnginesControllerMessage::writeData(SerializationOutputStream& output) {
  output.writeFloat(left);
  output.writeFloat(right);
  output.writeByte(mode);
  output.writeByte(enable);
}

