/*
 * This is the declaration of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#ifndef _HEADINPUTMESSAGE_H
#define	_HEADINPUTMESSAGE_H

#include "SimpleSerialization.h"

class HeadInputMessage : public SerializationData {
public:
    int getDataSize();
    void readData(SerializationInputStream& input);
    void writeData(SerializationOutputStream& output);
    long getMode(){return mode;};
    void setMode(long mode){this->mode = mode;};
    long getDelay(){return delay;};
    void setDelay(long delay){this->delay = delay;};
    long getAngle(){return angle;};
    void setAngle(long angle){this->angle = angle;};
    long getMeasureCount(){return measureCount;};
    void setMeasueCount(long measureCount){this->measureCount = measureCount;};
    long getRate(){return rate;};
    void setRate(long rate){this->rate = rate;};   
private:
    long mode = 2;
    long delay = 1000;
    long angle = 90;
    long measureCount = 1;
    long rate = 1000;
};

#endif	/* _HEADINPUTMESSAGE_H */
