/*
 * This is the declaration of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#ifndef _HEADOUTPUTMESSAGE_H
#define	_HEADOUTPUTMESSAGE_H

#include "SimpleSerialization.h"

class HeadOutputMessage : public SerializationData {
public:
    int getDataSize();
    void readData(SerializationInputStream& input);
    void writeData(SerializationOutputStream& output);
    long getUltrasonic(){return ultrasonic;};
    void setUltrasonic(long ultrasonic){this->ultrasonic = ultrasonic;};
    long getLidar(){return lidar;};
    void setLidar(long lidar){this->lidar = lidar;};
    long getLidarSignal(){return lidarSignal;};
    void setLidarSignal(long lidarSignal){this->lidarSignal = lidarSignal;};
    long getIrCode(){return irCode;};
    void setIrCode(long irCode){this->irCode = irCode;};
    long getServo(){return servo;};
    void setServo(long servo){this->servo = servo;};
private:
    long ultrasonic;
    long lidar;
    long lidarSignal;
    long irCode;
    long servo;
};

#endif	/* _HEADOUTPUTMESSAGE_H */
