/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "ImuMessage.h"

int ImuMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*9;
}

void ImuMessage::readData(SerializationInputStream& input) {
    accX = input.readFloat();
    accY = input.readFloat();
    accZ = input.readFloat();

    gyrX = input.readFloat();
    gyrY = input.readFloat();
    gyrZ = input.readFloat();

    magX = input.readFloat();
    magY = input.readFloat();
    magZ = input.readFloat();
}

void ImuMessage::writeData(SerializationOutputStream& output) {
  output.writeFloat(accX);
  output.writeFloat(accY);
  output.writeFloat(accZ);

  output.writeFloat(gyrX);
  output.writeFloat(gyrY);
  output.writeFloat(gyrZ);

  output.writeFloat(magX);
  output.writeFloat(magY);
  output.writeFloat(magZ);
}

