/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "KvByteMessage.h"

int KvByteMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*1+2;
}

void KvByteMessage::readData(SerializationInputStream& input) {
  key = input.readInteger();
  mode = input.readByte();
  value = input.readByte();
}

void KvByteMessage::writeData(SerializationOutputStream& output) {
  output.writeInteger(key);
  output.writeByte(mode);
  output.writeByte(value);
}

