/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "KvFloatMessage.h"

int KvFloatMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*2+1;
}

void KvFloatMessage::readData(SerializationInputStream& input) {
  key = input.readInteger();
  mode = input.readByte();
  value = input.readFloat();
}

void KvFloatMessage::writeData(SerializationOutputStream& output) {
  output.writeInteger(key);
  output.writeByte(mode);
  output.writeFloat(value);
}

