/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "KvIntMessage.h"

int KvIntMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*2+1;
}

void KvIntMessage::readData(SerializationInputStream& input) {
  key = input.readInteger();
  mode = input.readByte();
  value = input.readInteger();
}

void KvIntMessage::writeData(SerializationOutputStream& output) {
  output.writeInteger(key);
  output.writeByte(mode);
  output.writeInteger(value);
}

