/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "MagGpsInputMessage.h"

int MagGpsInputMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*4+1;
}

void MagGpsInputMessage::readData(SerializationInputStream& input) {
  magXoffset = input.readFloat();
  magYoffset = input.readFloat();
  magZoffset = input.readFloat();
  delay = input.readInteger();
  calib = input.readByte();
}

void MagGpsInputMessage::writeData(SerializationOutputStream& output) {
  output.writeFloat(magXoffset);
  output.writeFloat(magYoffset);
  output.writeFloat(magZoffset);
  output.writeInteger(delay);
  output.writeByte(calib);
}

