/*
 * This is the declaration of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#ifndef _MAGGPSINPUTMESSAGE_H
#define	_MAGGPSINPUTMESSAGE_H

#include "SimpleSerialization.h"

class MagGpsInputMessage : public SerializationData {
public:
    int getDataSize();
    void readData(SerializationInputStream& input);
    void writeData(SerializationOutputStream& output);

    float getMagXoffset() {return magXoffset;};
    void setMagXoffset(float magXoffset){this->magXoffset = magXoffset;};
    float getMagYoffset() {return magYoffset;};
    void setMagYoffset(float magYoffset){this->magYoffset = magYoffset;};
    float getMagZoffset() {return magZoffset;};
    void setMagZoffset(float magZoffset){this->magZoffset = magZoffset;};

    long getDelay() {return delay;};
    void setMagXoffset(long delay){this->delay = delay;};

    byte getCalib() {return calib;};
    void setCalib(byte calib){this->calib = calib;};

private:
    float magXoffset;
    float magYoffset;
    float magZoffset;
    long delay = 200;
    byte calib;
};

#endif	/* _MAGGPSINPUTMESSAGE_H */
