/*
 * This is the definition of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#include "MagGpsMessage.h"

int MagGpsMessage::getDataSize() {
  return SerializationTypes::SIZEOF_INTEGER*18;
}

void MagGpsMessage::readData(SerializationInputStream& input) {
    accX = input.readFloat();
    accY = input.readFloat();
    accZ = input.readFloat();

    gyrX = input.readFloat();
    gyrY = input.readFloat();
    gyrZ = input.readFloat();

    magX = input.readFloat();
    magY = input.readFloat();
    magZ = input.readFloat();

    gpsLat1 = input.readFloat();
    gpsLon1 = input.readFloat();
    gpsVal1 = input.readFloat();

    gpsLat2 = input.readFloat();
    gpsLon2 = input.readFloat();
    gpsVal2 = input.readFloat();

    gpsLat3 = input.readFloat();
    gpsLon3 = input.readFloat();
    gpsVal3 = input.readFloat();
}

void MagGpsMessage::writeData(SerializationOutputStream& output) {
  output.writeFloat(accX);
  output.writeFloat(accY);
  output.writeFloat(accZ);

  output.writeFloat(gyrX);
  output.writeFloat(gyrY);
  output.writeFloat(gyrZ);

  output.writeFloat(magX);
  output.writeFloat(magY);
  output.writeFloat(magZ);

  output.writeFloat(gpsLat1);
  output.writeFloat(gpsLon1);
  output.writeFloat(gpsVal1);

  output.writeFloat(gpsLat2);
  output.writeFloat(gpsLon2);
  output.writeFloat(gpsVal2);

  output.writeFloat(gpsLat3);
  output.writeFloat(gpsLon3);
  output.writeFloat(gpsVal3);
}

