/*
 * This is the declaration of the Message class whose instance (object) is going
 * to be serialized and sent via the serial connection.
 */

#ifndef _MAGGPSMESSAGE_H
#define	_MAGGPSMESSAGE_H

#include "SimpleSerialization.h"

class MagGpsMessage : public SerializationData {
public:
    int getDataSize();
    void readData(SerializationInputStream& input);
    void writeData(SerializationOutputStream& output);

    float getAccX(){return accX;};
    void setAccX(float accX){this->accX = accX;};
    float getAccY(){return accY;};
    void setAccY(float accY){this->accY = accY;};
    float getAccZ(){return accZ;};
    void setAccZ(float accZ){this->accZ = accZ;};

    float getGyrX(){return gyrX;};
    void setGyrX(float gyrX){this->gyrX = gyrX;};
    float getGyrY(){return gyrY;};
    void setGyrY(float gyrY){this->gyrY = gyrY;};
    float getGyrZ(){return gyrZ;};
    void setGyrZ(float gyrZ){this->gyrZ = gyrZ;};

    float getMagX(){return magX;};
    void setMagX(float magX){this->magX = magX;};
    float getMagY(){return magY;};
    void setMagY(float magY){this->magY = magY;};
    float getMagZ(){return magZ;};
    void setMagZ(float magZ){this->magZ = magZ;};

    float getLat1(){return gpsLat1;};
    void setLat1(float gpsLat1){this->gpsLat1 = gpsLat1;};
    float getLon1(){return gpsLon1;};
    void setLon1(float gpsLon1){this->gpsLon1 = gpsLon1;};
    float getVal1(){return gpsVal1;};
    void setVal1(float gpsVal1){this->gpsVal1 = gpsVal1;};

    float getLat2(){return gpsLat2;};
    void setLat2(float gpsLat2){this->gpsLat2 = gpsLat2;};
    float getLon2(){return gpsLon2;};
    void setLon2(float gpsLon2){this->gpsLon2 = gpsLon2;};
    float getVal2(){return gpsVal2;};
    void setVal2(float gpsVal2){this->gpsVal2 = gpsVal2;};

    float getLat3(){return gpsLat3;};
    void setLat3(float gpsLat3){this->gpsLat3 = gpsLat3;};
    float getLon3(){return gpsLon3;};
    void setLon3(float gpsLon3){this->gpsLon3 = gpsLon3;};
    float getVal3(){return gpsVal3;};
    void setVal3(float gpsVal3){this->gpsVal3 = gpsVal3;};


private:
    float accX;
    float accY;
    float accZ;

    float gyrX;
    float gyrY;
    float gyrZ;

    float magX;
    float magY;
    float magZ;

    float gpsLat1;
    float gpsLon1;
    float gpsVal1;

    float gpsLat2;
    float gpsLon2;
    float gpsVal2;

    float gpsLat3;
    float gpsLon3;
    float gpsVal3;  
};

#endif	/* _MAGGPSMESSAGE_H */
