from keyboard.keyboard import HidInputPublisher
from messages.arduino.Imu import Imu
from serialization.SerializationCoreBridge import SerializationCoreBridge
from messages.arduino.KvMessage import KvMessage, KvIntMessage, KvByteMessage, KvFloatMessage
from core.core import Core, TestSubscriber, TestPublisher
import time
from nav.ImuTransformationNode import ImuTransform
from socketio.socketio import FlaskBridge
from messages.TestMessage import TestMessage
from nav.EnginesController import EnginesController, SpeedMode, DirectionMode
from engines.DifferentialEnginesControl import DifferentialEnginesControl
from messages.MagnetoMessage import MagnetoMessage
from messages.socket.SocketMessages import StringMessage
import nav.calc.Calc
from test.FollowCards import FollowCards

if __name__ == '__main__':
    core = Core()
    hid = HidInputPublisher(core, "/hid")
    core.registerTopic(Imu().topic, Imu)
    core.registerTopic("/test", TestMessage)
    core.registerTopic(KvByteMessage().topic, KvByteMessage)

    s = SerializationCoreBridge(core, "/dev/ttyUSB0", 115200)
    s.subscribeArduino(Imu().topic)
    s.subscribeCore(KvByteMessage().topic, 4294901763, 4294901764)
    s.subscribeCore("/imu/magnetometer/calibrate", 4294901763, 4294901764)
    s.subscribeCore(KvIntMessage().topic, 4294901765, 4294901766)
    s.start()

    s2 = SerializationCoreBridge(core, "/dev/ttyUSB1", 115200)
    s2.subscribeCore("/control/engines/output", 123456789, 987654321)
    s2.start()

    tr = ImuTransform(core)

    time.sleep(10)
    msg = KvIntMessage()
    msg.value = 100
    core.publish(msg)

    fb = FlaskBridge(core)
    fb.subscribeTopic("/imu")

    ec = EnginesController(core)
    dif = DifferentialEnginesControl(core)
    fc = FollowCards(core, ec)