from serialization.SerializationData import SerializationData
from serialization.SerializationTypes import SerializationTypes
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream


class HeadInputMessage(SerializationData):
    #ultrasonic = 0
    #lidar = 0
    #lidarSignal = 0
    #irCode = 0
    def __init__(self, topic="/him", ultrasonic=None, lidar=None, lidarSignal=None, irCode=None, servo=90, *args, **kwargs):
        super().__init__()
        self.topic = topic
        self.ultrasonic = ultrasonic
        self.lidar = lidar
        self.lidarSignal = lidarSignal
        self.irCode = irCode
        self.servo = servo

    def __str__(self):
        return "Ultrasonic: {}\tLidar: {}\tSignal: {}\tIR: {}\tServo: {}".format(self.ultrasonic, self.lidar, self.lidarSignal, self.irCode, self.servo)

    def getDataSize(self):
        return SerializationTypes.SIZEOF_INTEGER*5

    def readData(self, input: SerializationInputStream):
        self.ultrasonic = input.readInteger()
        self.lidar = input.readInteger()
        self.lidarSignal = input.readInteger()
        self.irCode = input.readInteger()
        self.servo = input.readInteger()

    def writeData(self, output: SerializationOutputStream):
        output.writeInteger(self.ultrasonic)
        output.writeInteger(self.lidar)
        output.writeInteger(self.lidarSignal)
        output.writeInteger(self.irCode)
        output.writeInteger(self.servo)