from serialization.SerializationData import SerializationData
from serialization.SerializationTypes import SerializationTypes
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream


class HeadOutputMessage(SerializationData):
    #ultrasonic = 0
    #lidar = 0
    #lidarSignal = 0
    #irCode = 0
    def __init__(self, topic="/head", mode=0, delay=100, angle=90, measureCount=1, rate=100, *args, **kwargs):
        super().__init__()
        self.topic = topic
        self.mode = mode
        self.delay = delay
        self.angle = angle
        self.measureCount = measureCount
        self.rate = rate

    def getDataSize(self):
        return SerializationTypes.SIZEOF_INTEGER*5

    def readData(self, input: SerializationInputStream):
        self.mode = input.readInteger()
        self.delay = input.readInteger()
        self.angle = input.readInteger()
        self.measureCount = input.readInteger()
        self.rate = input.readInteger()

    def writeData(self, output: SerializationOutputStream):
        output.writeInteger(self.mode)
        output.writeInteger(self.delay)
        output.writeInteger(self.angle)
        output.writeInteger(self.measureCount)
        output.writeInteger(self.rate)