from HeadInputMessage import HeadInputMessage
from core.core import Core, TestSubscriber, TestPublisher
import random
import time
from threading import Thread

from messages.MagnetoMessage import MagnetoMessage
from nav.AP import ObstacleAvoidanceNode2

core = Core()


def himFeeder():
    for x in range(0, 181, 10):
        distance = 100
        msg = HeadInputMessage("/himb", distance, distance, distance, None, x)
        core.publish(msg)
    while True:
        for x in range(0, 181, 10):
            distance = random.randint(10, 100)
            msg = HeadInputMessage("/himb", distance, distance, distance, None, x)
            core.publish(msg)
            time.sleep(0.01)



def bearingFeeder():
    while True:
        bearing = random.randint(88, 92)
        msg = MagnetoMessage("/bearing", bearing)
        core.publish(msg)
        time.sleep(0.1)


if __name__ == '__main__':
    hft = Thread(target=himFeeder)
    bft = Thread(target=bearingFeeder)
    oan = ObstacleAvoidanceNode2(core)
    hft.start()
    bft.start()
    hft.join()
    bft.join()
    print("Complete")

