from messages.arduino.GenaralMessages import StringMessage
from messages.MessagesUtils import EmptyMessage
from core.core import Core, TestSubscriber
from serialization.SerializationCoreBridge import SerializationCoreBridge
from utils.StringUtils import containsValue


class StringMessageContains:
    mapper = {
        "L": "/strL",
        "C": "/strC",
        "R": "/strR"
    }

    def __init__(self, core: Core, topic: str):
        core.subscribe(topic, self.process)
        self.core = core

    def process(self, message: StringMessage):
        for key, value in self.mapper.items():
            if containsValue(message.message, key):
                core.publish(EmptyMessage(value))


if __name__ == '__main__':
    core = Core()
    core.setDebug(False)
    s = SerializationCoreBridge(core, "COM15")
    core.registerTopic("/str", StringMessage)
    s.subscribeArduino("/str", 4294901767, 4294901768)
    s.start()
    ts = TestSubscriber(core, "/str", True)
    tsl = TestSubscriber(core, "/strL", True)
    tsc = TestSubscriber(core, "/strC", True)
    tsr = TestSubscriber(core, "/strR", True)
    node = StringMessageContains(core, "/str")