from core.core import Core, TestSubscriber, TestPublisher
from socketio.socketio import FlaskBridge, FlaskBridgeParamNode
from nodes.GpsPathOperationNode import GpsPathOperationNode
from messages.MagnetoMessage import MagnetoMessage
from messages.GpsMessage import GpsMessage
from messages.core.Message import ValueMessage
from nodes.General import PersistConfigNode
import time, random


def gpsHeadingBearingSimulation(core: Core, fb: FlaskBridge):
    fb.subscribeTopic("/position/rover")
    fb.subscribeTopic("/heading")
    fb.subscribeTopic("/bearing")
    g = GpsPathOperationNode(core, fb)



if __name__ == '__main__':
    core = Core()
    fb = FlaskBridge(core)
    gpsHeadingBearingSimulation(core, fb)

    core.registerTopic("/bridgeCoreParam/nav/okdistance", ValueMessage)
    ts = TestSubscriber(core, "/bridgeCoreParam/nav/okdistance", True)

    topics = [
        "/nav/okdistance",
        "/nav/minimalDistances",
    ]
    pcn = PersistConfigNode(core)
    fbpn = FlaskBridgeParamNode(core, fb, topics)

    latr = (49.1, 49.2)
    lonr = (13.1, 13.2)
    angl = (60, 90)
    while True:
        core.publish(MagnetoMessage(topic="/heading", heading=random.uniform(angl[0], angl[1])))
        core.publish(MagnetoMessage(topic="/bearing", heading=random.uniform(angl[0], angl[1])))
        core.publish(GpsMessage(topic="/position/rover", lat=random.uniform(latr[0], latr[1]), lon=random.uniform(lonr[0], lonr[1])))
        core.publish(GpsMessage(topic="/gps", lat=random.uniform(latr[0], latr[1]), lon=random.uniform(lonr[0], lonr[1])))
        time.sleep(1)
