from messages.arduino.Imu import Imu
from serialization.SerializationCoreBridge import SerializationCoreBridge
from messages.arduino.KvMessage import KvMessage, KvIntMessage, KvByteMessage, KvFloatMessage
from core.core import Core, TestSubscriber, TestPublisher
import time
from nav.ImuTransformationNode import ImuTransform
from socketio.socketio import FlaskBridge, FlaskBridgeParamNode
from messages.TestMessage import TestMessage
from nav.EnginesController import EnginesController, SpeedMode, DirectionMode
from engines.DifferentialEnginesControl import DifferentialEnginesControl
from messages.MagnetoMessage import MagnetoMessage
from messages.arduino.GenaralMessages import StringMessage
import nav.calc.Calc
from messages.MessagesUtils import ParamSyncNode, ParamSyncRule, MessageModeType
from messages.core.Message import ErrorMessage, EmptyMessage, ValueMessage

if __name__ == '__main__':
    core = Core()
    core.setDebug(False)
    core.registerTopic("/test", TestMessage)
    core.registerTopic("/control/engines/enable", ValueMessage)

    s = TestSubscriber(core, "/test", True)
    s1 = TestSubscriber(core, "/control/engines/enable", True)

    fb = FlaskBridge(core)
    topics = [
        "/DirectionController/turnCoef",
        "/DirectionController/turnMode"
    ]

    fbpn = FlaskBridgeParamNode(core, fb, topics)
