from core.core import Core, TestSubscriber
from messages.arduino.Imu import Imu
from messages.arduino.KvMessage import KvFloatMessage, KvByteMessage, KvIntMessage
from serialization.SerializationCoreBridge import SerializationCoreBridge
from messages.arduino.GenaralMessages import StringMessage

if __name__ == '__main__':
    core = Core()
    print(core.config)
    core.setDebug(True)

    core.registerTopic("/kvFromArduino", KvFloatMessage)
    core.registerTopic("/str", StringMessage)
    core.registerTopic(Imu().topic, Imu)

    s = SerializationCoreBridge(core, core.getParam("/arduino/imu/com"), 115200)
    s.subscribeArduino(Imu().topic)
    s.subscribeCore(KvFloatMessage().topic, 4294901769, 4294901770)
    s.subscribeArduino("/kvFromArduino", 4294901769, 4294901770)
    s.subscribeArduino("/str", 4294901767, 4294901768)

    s.subscribeCore(KvByteMessage().topic, 4294901763, 4294901764)
    s.subscribeCore("/imu/magnetometer/calibrate", 4294901763, 4294901764)
    s.subscribeCore(KvIntMessage().topic, 4294901765, 4294901766)
    s.start()

    ts = TestSubscriber(core, Imu().topic, True)