from HeadInputMessage import HeadInputMessage
from messages.GpsMessage import GpsMessage
from core.core import Core, TestSubscriber
from socketio.socketio import FlaskBridge
from nav.NavObjects import GeoPoint
import time


if __name__ == '__main__':
    core = Core()

    def resender(message: GeoPoint):
        core.publish(GeoPoint("/position/destination", message.lat, message.lon))


    fb = FlaskBridge(core)
    core.registerTopic("/position/rover", GpsMessage)
    fb.subscribeTopic("/position/rover")
    fb.subscribeTopic("/him")
    fb.subscribeTopic("/himb")
    fb.subscribeTopic("/position/destination")
    core.registerTopic("/destinationPoint", GeoPoint)
    ts = TestSubscriber(core, "/destinationPoint", True)
    core.subscribe("/destinationPoint", resender)
    messages = [
        GeoPoint(topic="/position/rover", lat=49.1, lon=13.1),
        GeoPoint(topic="/position/rover" ,lat=49.1, lon=13.1)
    ]
    while True:
        # core.publish(HeadInputMessage(topic="/himb", ultrasonic=30, servo=90))
        for message in messages:
            core.publish(message)
            time.sleep(1)
