from serialization.SerializationData import SerializationData
from serialization.SerializationTypes import SerializationTypes
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream

class TimerMessage(SerializationData):
    hour = 0
    minute = 0
    second = 0
    preamble = 11223344
    postamble = 44332211

    def getDataSize(self):
        return SerializationTypes.SIZEOF_INTEGER*3

    def readData(self, input: SerializationInputStream):
        self.hour = input.readInteger()
        self.minute = input.readInteger()
        self.second = input.readInteger()

    def writeData(self, output: SerializationOutputStream):
        output.writeInteger(self.hour)
        output.writeInteger(self.minute)
        output.writeInteger(self.second)