from serialization.SerializationData import SerializationData
from serialization.SerializationTypes import SerializationTypes
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream

class UltrasonicParamsMessage(SerializationData):

    def __init__(self):
        super().__init__()
        self.delay = 1000
        self.timeout = 400000

    def getDataSize(self):
        return SerializationTypes.SIZEOF_INTEGER*2

    def readData(self, input: SerializationInputStream):
        self.delay = input.readInteger()
        self.timeout = input.readInteger()

    def writeData(self, output: SerializationOutputStream):
        output.writeInteger(self.delay)
        output.writeInteger(self.timeout)