from engines.EnginesContol import EnginesControl
from core.core import Core
from messages.arduino.BridgeMessage import BridgeMessage
from utils.ConvertUtils import booleanToByte
from nav.calc.Calc import AckermannToDifferential, toRange


class DifferentialEnginesControl(EnginesControl):

    def __init__(self, core: Core):
        super().__init__(core)
        self.atd = AckermannToDifferential()
        self.message = BridgeMessage()

    def soft(self, value: bool):
        self.atd.soft = value

    def setEngines(self, speed, direction):
        self.message.left, self.message.right, self.message.mode = self.atd.transform(speed, direction)
        self.message.left = toRange(int(abs(self.message.left)), 0, 255)
        self.message.right = toRange(int(abs(self.message.right)), 0, 255)
        self.message.enable = self.enable
        self.core.publish(self.message)
