import messages.arduino
import messages.core.EnginesControlMessage
import messages.arduino.Imu
import messages.arduino.KvMessage
import messages.arduino.MagGpsMessage

topicMapper = {}

messagesRegister = [
    messages.arduino.Imu.Imu,
    messages.arduino.KvMessage.KvByteMessage,
    messages.arduino.KvMessage.KvFloatMessage,
    messages.arduino.KvMessage.KvIntMessage,
    messages.arduino.MagGpsMessage.MagGpsMessage
]


def generateTopicMapper() -> {}:
    for msg in messagesRegister:
        inst = msg()
        topicMapper[inst.topic] = msg

if __name__ == '__main__':
    generateTopicMapper()
    print(topicMapper)