from serialization.SerializationData import SerializationData, SerializationOutputStream, SerializationInputStream, SerializationTypes


class StringMessage(SerializationData):

    def __init__(self, topic="/str", message="", *args, **kwargs):
        super().__init__()
        self.topic = topic
        self.message = message

    def __str__(self):
        return "Message: {}\tsize: {}".format(self.message, len(self.message))

    def getDataSize(self):
        return SerializationTypes.SIZEOF_STRING + len(self.message)

    def readData(self, input: SerializationInputStream):
        self.message = input.readString()

    def writeData(self, output: SerializationOutputStream):
        output.writeString(self.message)