from serialization.SerializationData import SerializationData
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream


class MagGpsInputMessage(SerializationData):

    def __init__(self, topic="/maggpsinput", magXoffset=0,magYoffset=0, magZoffset=0, delay=0, calib = 0):
        super().__init__()
        self.preamble = 123456789
        self.postamble = 987654321
        self.topic = topic
        self.magXoffset = magXoffset
        self.magYoffset = magYoffset
        self.magZoffset = magZoffset
        self.delay = delay
        self.calib = calib

    def __str__(self):
        return "calib "+str(self.calib)

    def getDataSize(self):
        return (4*4) + 1

    def readData(self, input: SerializationInputStream):
        self.magXoffset = input.readFloat()
        self.magYoffset = input.readFloat()
        self.magZoffset = input.readFloat()
        self.delay = input.readInteger()
        self.calib = input.readByte()

    def writeData(self, output: SerializationOutputStream):
        output.writeFloat(self.magXoffset)
        output.writeFloat(self.magYoffset)
        output.writeFloat(self.magZoffset)
        output.writeInteger(self.delay)
        output.writeByte(self.calib)

