from serialization.SerializationData import SerializationData
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream
import math


class MagGpsMessage(SerializationData):

    def __init__(self, topic="/maggps", accX=0, accY=0, accZ=0,gyrX=0,gyrY=0,gyrZ=0,magX=0,magY=0,magZ=0,gpsLat1=0,gpsLon1=0,gpsVal1=0,gpsLat2=0,gpsLon2=0,gpsVal2=0,gpsLat3=0,gpsLon3=0,gpsVal3=0, *args, **kwargs):
        super().__init__()
        self.topic = topic
        self.accX = accX
        self.accY = accY
        self.accZ = accZ
        self.gyrX = gyrX
        self.gyrY = gyrY
        self.gyrZ = gyrZ
        self.magX = magX
        self.magY = magY
        self.magZ = magZ
        self.gpsLat1 = gpsLat1
        self.gpsLon1 = gpsLon1
        self.gpsVal1 = gpsVal1
        self.gpsLat2 = gpsLat2
        self.gpsLon2 = gpsLon2
        self.gpsVal2 = gpsVal2
        self.gpsLat3 = gpsLat3
        self.gpsLon3 = gpsLon3
        self.gpsVal3 = gpsVal3

    def __str__(self):
        heading = 180 - math.atan2(self.magX, self.magY) / 0.0174532925
        return "Mag "+str(heading)+"\tRAW: "+str(self.magX)+" "+str(self.magY)+" "+str(self.magZ)

    def getDataSize(self):
        return 18*4

    def readData(self, input: SerializationInputStream):
        self.accX = input.readFloat()
        self.accY = input.readFloat()
        self.accZ = input.readFloat()
        self.gyrX = input.readFloat()
        self.gyrY = input.readFloat()
        self.gyrZ = input.readFloat()
        self.magX = input.readFloat()
        self.magY = input.readFloat()
        self.magZ = input.readFloat()
        self.gpsLat1 = input.readFloat()
        self.gpsLon1 = input.readFloat()
        self.gpsVal1 = input.readFloat()
        self.gpsLat2 = input.readFloat()
        self.gpsLon2 = input.readFloat()
        self.gpsVal2 = input.readFloat()
        self.gpsLat3 = input.readFloat()
        self.gpsLon3 = input.readFloat()
        self.gpsVal3 = input.readFloat()


    def writeData(self, output: SerializationOutputStream):
        output.writeFloat(self.accX)
        output.writeFloat(self.accY)
        output.writeFloat(self.accZ)
        output.writeFloat(self.gyrX)
        output.writeFloat(self.gyrY)
        output.writeFloat(self.gyrZ)
        output.writeFloat(self.magX)
        output.writeFloat(self.magY)
        output.writeFloat(self.magZ)
        output.writeFloat(self.gpsLat1)
        output.writeFloat(self.gpsLon1)
        output.writeFloat(self.gpsVal1)
        output.writeFloat(self.gpsLat2)
        output.writeFloat(self.gpsLon2)
        output.writeFloat(self.gpsVal2)
        output.writeFloat(self.gpsLat3)
        output.writeFloat(self.gpsLon3)
        output.writeFloat(self.gpsVal3)

