from messages.core.Message import Message

class EnginesControlMessage(Message):
    MIN_VAL = 0
    MAX_VAL = 180
    def __init__(self, topic="/control/engines", speed=90, direction=90, *args, **kwargs):
        super().__init__(topic)
        self.speed = speed
        self.direction = direction

    def setSpeed(self, speed):
        self.speed = self.normalize(speed)

    def setDirection(self, direction):
        self.direction = self.normalize(direction)

    def normalize(self, value):
        if value > self.MAX_VAL:
            return self.MAX_VAL
        if value < self.MIN_VAL:
            return self.MIN_VAL
        return value

    def __str__(self):
        return "Speed: "+str(self.speed)+" Direction: "+str(self.direction)