class Message:

    def __init__(self, topic="", *args, **kwargs):
        self.topic = topic


class ValueMessage(Message):

    def __init__(self, topic="/", value=None, *args, **kwargs):
        super().__init__(topic)
        self.value = value

    def __str__(self):
        return "Value: {}".format(self.value)


class KeyValueMessage(Message):

    def __init__(self, topic="/", key=None, value=None, *args, **kwargs):
        super().__init__(topic)
        self.key = key
        self.value = value

    def __str__(self):
        return "Key: {}\tValue: {}".format(self.key, self.value)


class ErrorMessage(Message):

    def __init__(self, message=None, *args, **kwargs):
        super().__init__("/error")
        self.message = message

    def __str__(self):
        return "ERROR: {}".format(self.message)


class InfoMessage(Message):

    def __init__(self, message=None, *args, **kwargs):
        super().__init__("/info")
        self.message = message

    def __str__(self):
        return "INFO: {}".format(self.message)


class EmptyMessage:

    def __init__(self, topic="/", *args, **kwargs):
        self.topic = topic
