from messages.core.Message import Message


class GamepadMessage(Message):

    def __init__(self, topic="/gamepad", lax=0, lay=0, rax=0, ray=0, btn1=0, btn2=0, btn3=0, btn4=0, *args, **kwargs):
        super().__init__(topic, *args, **kwargs)
        self.lax = lax
        self.lay = lay
        self.rax = rax
        self.ray = ray
        self.b0 = 0
        self.b1 = btn1
        self.b2 = btn2
        self.b3 = btn3
        self.b4 = btn4

    def __str__(self):
        return "lax: {} lay: {} rax: {} ray: {} b0: {} b1: {} b2: {} b3: {} b4: {}".format(
            self.lax,
            self.lay,
            self.rax,
            self.ray,
            self.b0,
            self.b1,
            self.b2,
            self.b3,
            self.b4
        )


