from messages.arduino.Imu import Imu, ImuMessage
from messages.MagnetoMessage import MagnetoMessage
from messages.arduino.KvMessage import KvMessage, KvByteMessage, KvIntMessage, KvFloatMessage
from core.core import Core, Node


class ImuTransform:

    def __init__(self, core: Core):
        self.core = core
        core.subscribe("/imuRaw", self.process)
        self.message = ImuMessage()
        self.magnetoMessage = MagnetoMessage()

    def process(self, message: Imu):
        self.message.heading = message.getHeading()
        self.magnetoMessage.heading = message.getHeading()
        self.core.publish(self.message)
        self.core.publish(self.magnetoMessage)


class ImuConfigurator(Node):
    mapper = {
        "/imu/mangeto/xOffset": [0, KvFloatMessage],
        "/imu/mangeto/yOffset": [1, KvFloatMessage],
        "/imu/mangeto/zOffset": [2, KvFloatMessage]
    }

    def __init__(self, core: Core, imuConfigTopic="/"):
        super().__init__(core)
        self.topic = imuConfigTopic

    def load(self):
        val = self.core.getParam("/imu/magneto/xOffset")