import collections
import statistics


class CircularBuffer:

    def __init__(self, size):
        self.buffer = collections.deque(maxlen=size)

    def append(self, value):
        self.buffer.append(value)

    def mean(self):
        return statistics.mean(self.buffer)

    def mod(self):
        return statistics.mode(self.buffer)

    def med(self):
        return statistics.median(self.buffer)


class Buffer:

    def __init__(self):
        self.buffer = []

    def append(self, value):
        self.append(value)

    def clear(self):
        self.buffer = []


if __name__ == '__main__':
    d = collections.deque(maxlen=3)
    print(d)

    d.append(1)
    d.append(2)
    d.append(3)
    d.append(4)
    d.append(5)

    print(statistics.mean(d))

    b = CircularBuffer(3)
    b.append(1)
    b.append(2)
    b.append(3)
    b.append(4)
    b.append(5)
    print(b.mean())