import statistics
import scipy.stats.mstats as stat


class Stat:

    def __init__(self):
        self.stat = {
            1: statistics.mean,
            2: statistics.mode,
            3: statistics.median,
        }

    def winsorize(self, list, limit):
        x = stat.winsorize(list, limits=limit, inplace=False)
        return x

    @staticmethod
    def mean(list):
        return statistics.mean(list)

    @staticmethod
    def mod(list):
        return statistics.mode(list)

    @staticmethod
    def med(list):
        return statistics.median(list)

    def getValue(self, data, mode):
        return self.stat[mode](data)

if __name__ == '__main__':
    l = [1,5,6,8,9,8,10,21,12,17,13,89,13]
    s = Stat()
    s.winsorize(l,0.5)
    print(s.getValue(l,1))
    print(s.stat[1](l))