from core.core import Core, Node
from messages.socket.GamepadMessage import GamepadMessage
from utils.ConvertUtils import Button
from messages.core.Message import KeyValueMessage


class GamepadButtonsNode(Node):

    def __init__(self, core: Core):
        super().__init__(core)
        self.core.registerTopic("/gamepad", GamepadMessage)
        self.core.subscribe("/gamepad", self.process)
        self.b1 = Button()
        self.b2 = Button()

    def process(self, message: GamepadMessage):
        if self.b1.encode(message.b1):
            m = KeyValueMessage("/DirectionController/mode", 3, 0)
            self.core.publish(m)
        if self.b2.encode(message.b2):
            m = KeyValueMessage("/DirectionController/mode", 1, 90)
            self.core.publish(m)
