from core.core import Core
from messages.core.Message import ValueMessage


class RemoteValue:

    def __init__(self, core: Core, topic="", value=None, onUpdateCallback=None):
        self.core = core
        self.topic = topic
        self.value = value
        self.onUpdateCallback = onUpdateCallback
        self.core.subscribe(topic, self.onUpdate)

    def onUpdate(self, message: ValueMessage):
        self.value = message.value
        if self.onUpdateCallback is not None:
            self.onUpdateCallback(self.value)

    def update(self, value):
        self.value = value
        self.core.publish(ValueMessage(self.topic, self.value))


class ParamValue:

    def __init__(self, core: Core, param: str):
        self.core = core
        self.param = param
        self.value = self.core.getParam(param)
        self.core.addOnParamChangeCallback(self.param, self.onUpdate)

    def onUpdate(self, value):
        self.value = value

    def update(self, value):
        self.value = value
        self.core.setParam(self.param, self.value)


