from serialization.SerializationTypes import SerializationTypes
from serialization.SerializationInputStream import SerializationInputStream
from serialization.SerializationOutputStream import SerializationOutputStream


class SerializationData:

    def __init__(self, topic="/", preamble=123456789, postamble=987654321, *args, **kwargs):
        self.topic = topic
        self.preamble = preamble
        self.postamble = postamble
        self.checksum = 0
        self.listeners = []

    def getSize(self):
        size = SerializationTypes.SIZEOF_INTEGER
        size += SerializationTypes.SIZEOF_INTEGER
        size += self.getDataSize()
        size += SerializationTypes.SIZEOF_INTEGER
        return size

    def getDataSize(self):
        pass

    def readData(self, input):
        pass

    def writeData(self, output):
        pass

    def read(self, input: SerializationInputStream):
        self.preamble = input.readInteger()
        self.checksum = input.readInteger()
        self.readData(input)
        self.postamble = input.readInteger()

    def write(self, output: SerializationOutputStream):
        output.writeInteger(self.preamble)
        output.writeInteger(self.getSize())
        self.writeData(output)
        output.writeInteger(self.postamble)

    def addListener(self, listener):
        self.listeners.append(listener)

    def notifyListeners(self):
        for listener in self.listeners:
            listener.dataUpdate(self)


if __name__ == '__main__':
    x = SerializationData()
    # print(x.__preamble)
    x.__preamble = 10
    print(x.__preamble)
    print(x.getPreamble())
