from serialization.SerializationTypes import SerializationTypes

class SerializationOutputStream:
    #buffer = []

    def __init__(self, size):
        self.size = size
        self.buffer = []

    def write(self, b):
        self.buffer.append(b)

    def writeInteger(self, intVal):
        buffer = SerializationTypes.integerToBytes(intVal)
        for b in buffer:
            self.buffer.append(b)

    def writeFloat(self, floatValue):
        buffer = SerializationTypes.float_to_bytes(floatValue)
        for b in buffer:
            self.buffer.append(b)

    def writeString(self, strVal):
        self.writeInteger(len(strVal))
        self.buffer.append(bytearray(strVal))

    def writeByte(self, b):
        self.write(b)