import struct
import binascii

class SerializationTypes:
    SIZEOF_INTEGER = 4
    SIZEOF_FLOAT = 4
    SIZEOF_STRING = 4

    @staticmethod
    def bytesToInteger(bytes):
        val = 0
        val += (bytes[0] & 0xff) << 24
        val += (bytes[1] & 0xff) << 16
        val += (bytes[2] & 0xff) << 8
        val += (bytes[3] & 0xff)
        #return val
        return SerializationTypes.int_from_bytes(bytes)

    @staticmethod
    def integerToBytes(int):
        return SerializationTypes.int_to_bytes(int)

    @staticmethod
    def int_to_bytes(x: int) -> bytes:
        #return x.to_bytes((x.bit_length() + 7) // 8, 'big')
        return x.to_bytes(SerializationTypes.SIZEOF_INTEGER, byteorder='big')
        #return x.to_bytes((x.bit_length() + 7) // 8, 'big')

    @staticmethod
    def float_to_bytes(x: float) ->bytes:
        return struct.pack('f', x)

    @staticmethod
    def int_from_bytes(xbytes: bytes) -> int:
        return int.from_bytes(xbytes, 'big')

    def int_to_bytesNefunkcni(i: int, *, signed: bool = False) -> bytes:
        if i < 0:
            signed = True
        length = ((i + ((i * signed) < 0)).bit_length() + 7 + signed) // 8
        return i.to_bytes(length, byteorder='big', signed=signed)

    @staticmethod
    def float_from_bytes(xbytes: bytes) -> float:
        var = struct.unpack('<f', bytearray(xbytes))
        return var[0]
        #x = struct.unpack('f', xbytes)
        #return x
        #var = struct.unpack('f', binascii.hexlify(bytearray(xbytes)).decode('hex'))[0]
        #return var