from threading import Thread
from socketIO_client import SocketIO

host = '127.0.0.1'
port = 5000


class TwoWayClient(object):
    def on_event(self, event):
        print(event)

    def on_connect(self):
        print('connect')

    def __init__(self):
        self.socketio = SocketIO(host, port)
        self.socketio.on('robotOut', self.on_event, "/pubsub")
        self.socketio.on('connect', self.on_connect, "/pubsub")

        self.receive_events_thread = Thread(target=self._receive_events_thread)
        self.receive_events_thread.daemon = True
        self.receive_events_thread.start()

        while True:
            some_input = input()
            self.socketio.emit('event', some_input)

    def _receive_events_thread(self):
        self.socketio.wait()


def main():
    TwoWayClient()


if __name__ == "__main__":
    main()