from messages.GpsMessage import GpsMessage
from nav.NavObjects import GeoPoint, WayPoint


def booleanToByte(boolean: bool) -> int:
    if boolean:
        return 1
    else:
        return 0

def byteToBoolean(byte: int) -> bool:
    if byte == 0:
        return False
    return True

class Button:

    def __init__(self):
        self.echo = False

    def encode(self, value):
        if byteToBoolean(value):
            if self.echo is False:
                self.echo = True
                return True
        else:
            self.echo = False
        return False

def setTopic(messageNew, messageOriginal, **kwargs):
    messageNew.topic = kwargs.get("topic", messageOriginal.topic)

def setLatLonMessage(messageNew, messageOriginal, **kwargs):
    messageNew.lat = messageOriginal.lat
    messageNew.lon = messageOriginal.lon
    setTopic(messageNew, messageOriginal, **kwargs)

def convertToGeoPoint(message: GpsMessage, **kwargs) -> GeoPoint:
    output = GeoPoint()
    setLatLonMessage(output, message, **kwargs)
    return output

def convertToWaypoint(message: GpsMessage, **kwargs) -> WayPoint:
    output = WayPoint()
    output.name = kwargs.get("name",None)
    setLatLonMessage(output, message, **kwargs)
    return output


def convertToGeoPointWaypoint(message: WayPoint) -> GeoPoint:
    output = GeoPoint()
    output.lat = message.lat
    output.lon = message.lon
    return output


if __name__ == '__main__':
    x = convertToWaypoint(GpsMessage(lat=5, lon=10))
    print(x.name)
    print(x.topic)