import os
from pathlib import Path
import utils.TimeUtils
from utils.TimeUtils import oneDigitNormalize
import jsonpickle

def readUtf8(path) -> str:
    myfile = open(path,'r', encoding='utf-8')
    content = myfile.read()
    myfile.close()
    return content

def writeUtf8(path, content: str):
    myfile = open(path, 'w', encoding='utf-8')
    myfile.write(content)
    myfile.close()

def writeUtf8IfDifferent(path, content: str):
    if os.path.exists(path):
        if readUtf8(path) != content:
            writeUtf8(path, content)
    else:
        writeUtf8(path, content)


def createDirectories(path):
    Path(path).mkdir(parents=True, exist_ok=True)


def argsToString(args):
    li = list(args)
    for x in range(len(li)):
        li[x] = str(li[x])
    return tuple(li)


def getPathBase(base, *args):
    args = argsToString(args)
    output = os.path.sep.join([base, os.path.sep.join(args)])
    return output


def getPath(*args):
    args = argsToString(args)
    return os.path.sep.join(args)


def getDatePath():
    date = utils.TimeUtils.getDate()
    return getPath(date.year, date.month, date.day)

def getDateTimePath():
    date = utils.TimeUtils.getDate()
    time = utils.TimeUtils.getTime()
    return getPath(date.year, oneDigitNormalize(date.month), oneDigitNormalize(date.day), "-".join((oneDigitNormalize(time.hour), oneDigitNormalize(time.minute), oneDigitNormalize(time.second))))


def deserialize(path):
    return jsonpickle.decode(utils.IOUtils.readUtf8(path))

def serialize(path, obj):
    utils.IOUtils.writeUtf8IfDifferent(path, jsonpickle.encode(obj))




if __name__ == '__main__':
    # writeUtf8IfDifferent('text.txt', "Ahojx")
    # print(readUtf8("text.txt"))
    print(getDateTimePath())