import jsons
import json
import jsonpickle
from collections import namedtuple


class TestClass:

    def __init__(self, topic="", value=None, **kwargs):
        self.topic = topic
        self.value = value

    def __str__(self):
        return "TestClass Topic: {} Value: {}".format(self.topic, self.value)



def toJson(content):
    x = jsons.dump(content)
    return x

# DEFAULT
def toJson2(content):
    x = json.dumps(content.__dict__, default=lambda o: '<not serializable>')
    return x

# DEFAULT PICKLE
def toJson2Pickle(content):
    x = jsonpickle.encode(content)
    return x


def toObject(content):
    return jsons.load(content)


def _jaon_object_hook(d):
    return namedtuple('Y', d.keys())(*d.values())


def jsonToObject(data):
    return json.loads(data, object_hook=_jaon_object_hook)

def to_json(obj):
    return jsonpickle.encode(obj)

def from_json2(class_type, json_str):
    # Get the class type from py/type
    type_dict_str = to_json(class_type)
    json_type_dict = json.loads(type_dict_str)

    # Set the py/object with py/type from passed class
    json_dict = json.loads(json_str)
    json_dict.update({"py/object": json_type_dict["py/type"]})
    return jsonpickle.decode(json.dumps(json_dict))

# DEFAULT
def toObject(content, clazz):
    obj = json.loads(content, object_hook=lambda d: clazz(**d))
    return obj

# DEFAULT PICKLE
def toObjectPickle(content, clazz):
    x = from_json2(clazz, content)
    return x


if __name__ == '__main__':
    obj = TestClass("topic1", value=True)
    jsonVal = toJson2(obj)
    obj2 = toObject(jsonVal, TestClass)
    print(obj)
    print(jsonVal)
    print(obj2)
