class Progress:

    def __init__(self):
        self.list = []
        self.pointer = 0

    def setData(self, list: []):
        self.list = list
        self.reset()

    def reset(self):
        self.pointer = 0

    def hasNext(self):
        return self.pointer < len(self.list)

    def next(self):
        out = self.list[self.pointer]
        self.pointer += 1
        return out

    def remain(self):
        return len(self.list)-self.pointer

    def passed(self):
        return self.pointer

    def progress(self):
        return self.passed() / len(self.list) *100

if __name__ == '__main__':
    list = []
    for x in range(13):
        list.append("X"+str(x))

    p = Progress()
    p.setData(list)
    while p.hasNext():
        print(p.next())
        print(p.passed())
        print(p.remain())
        print(p.progress())
        print("##")
