from flask import session, redirect, url_for, render_template, request
from . import main
import json
import os

@main.route('/')
def index():
    return render_template('index.html')

@main.route('/pubsub')
def pubSub():
    return render_template('pubsub.html')

@main.route('/g')
def gamepad():
    return render_template('gamepad.html')

@main.route('/debug')
def debug():
    return render_template('debug.html')

@main.route('/ap')
def ap():
    return render_template('ap.html')

@main.route('/chart')
def chart():
    return render_template('chart.html')

@main.route('/map')
def map():
    return render_template('map.html')

@main.route('/test')
def test():
    return render_template('test.html')

def path_to_dict(path, root):
    d = {'name': os.path.basename(path)}
    if os.path.isdir(path):
        d['type'] = "directory"
        d['children'] = [path_to_dict(os.path.join(path,x), root) for x in os.listdir\
(path)]
    else:
        d['path'] = str(os.path.relpath(path, root))
        d['type'] = "file"
    return d

@main.route('/media', methods= ['POST', 'GET'])
def media():
    id = None
    if request.method == 'POST':
        print(request.form)
        id = request.form['id']
        print(id)
    directory = "/home/pi/python/projects/FlaskSocketIOChat/app/static/media"
    menu = path_to_dict(directory, directory)
    date = None
    finalPath = "/home/pi/python/projects/FlaskSocketIOChat/app/static/media/2020/01/04/12-02-52/info.json"
    if id is not None:
        finalPath = os.path.join(directory, id)
    with open(finalPath) as json_file:
        data = json.load(json_file)
    if id is None:
        return render_template('media.html', data = data, menu = menu)
    else:
        return render_template('pathView.html', data=data)



