//bridge = function(){

var socket;
var map = {};
var inMsg;
var rawMsg;
const GAMEPAD_SEND_TIMEOUT = 100

function registerSubscribers(){
    var subscribers = $(".bridge-subscriber");
    var length = subscribers.length;
    for(var i=0;i<length;i++){
        var topic = getTopicFromClasses(getClasses(subscribers[i]));
        if(topic==null) { continue; }
        registerSubscriber(subscribers[i],topic);
    }
}

function registerPublishers(){
    var publishers = $(".bridge-publisher");
    var length = publishers.length;
    for(var i=0;i<length;i++){
        var topic = getTopicFromClasses(getClasses(subscribers[i]));
        if(topic==null) {continue;}

    }
}

function registerSubscriber(element, topic){
    var subs = map[topic];
    if(subs==null){
        subs = [element];
    }else{
        subs.push(element);
    }
    map[topic] = subs;
}

function getClasses(element){
    return $(element).attr("class").split(/\s+/);
}

function getTopicFromClasses(classes){
    var length = classes.length;
    for(var i=0;i<length;i++){
        if(classes[i].startsWith("/")){
            return classes[i];
        }
    }
    return null;
}

function publish(message){
    var subscribers = map[message.topic];
    var length = subscribers.length;
    for(var i = 0;i<length;i++){
        updateFormObj(subscribers[i],message);
    }
}

function publish2(message){
    $("[data-bridge-subscriber="+message.topic+"]").each(function() {
        for(var i = 0; i< this.length;i++){
            for (let [key, value] of Object.entries(this[i])) {
                $(this[i]).find("[data-bridge="+key+"]").val(value);
            }
        }
    });
}

function publishToMap(message){
    var x = map[message.topic];
    if(x == null){ return; }
    x(message);
}

function publish3(message){
    var x = $("[data-bridge-subscriber="+message.topic+"]");
    for(var i=0;i<x.length;i++){
        for (let [key, value] of Object.entries(message)) {
           $(x[i]).find("[data-bridge="+key+"]").val(value);
        }
    }
}

function publishDebug(message, original){
    var debug = $(".debug")
    if(debug){
        var topic = $(debug).find("[data-topic="+message.topic+"]");
        if(topic.length > 0){
            var val = $(topic).find(".counter");
            $(val).text(parseInt(val.text(),10)+1);
            $(topic).find(".content").text(original);
        }else{
            $("<div class=\"d-inline-block\" data-topic="+message.topic+"><p class=\"d-inline-block\">"+message.topic+"</p><p class=counter d-inline>0</p><p class=content d-inline>"+original+"</p></div>").appendTo(".debug");
        }
    }
}

function send(){

}

function updateFormObj(segment, message){
    for (let [key, value] of Object.entries(message)) {
        var el = $(segment).find('[name='+key+']');
        if(el!=null){
            $(el).val(value);
        }

    }
}

function triggerMessage() {
            setInterval(function(){
                socket.emit('topicPublisher',{});
             }, 3000);
        }

function triggerGamepad() {
            setInterval(function(){
                gamepadEvent();
             }, GAMEPAD_SEND_TIMEOUT);
        }

function random(){
    var min=0;
    var max=180;
    var random = Math.floor(Math.random() * (+max - +min)) + +min;
    return random;
}

function map(val,oldMin,oldMax,newMin,newMax){
    return (((val - oldMin) * (newMax - newMin)) / (oldMax - oldMin)) + newMin;
}

function gamepadEvent(){
    var element = $("[data-bridge-publisher*="+"/gamepad"+"] > [data-bridge="+"lax"+"]");
    publishToBridgeDelay(element);
}

function publishToBridge(element){
    var x = $(element).parent().find("[data-bridge*="+""+"]");
    var msg =$(element).parent().attr("data-bridge-publisher")+"\n";
    for(var i=0;i<x.length;i++){
        msg += $(x[i]).attr("data-bridge")+" "+(x[i]).value+"\n";
    }
    alert(msg);
}

var lastSend = {};
var publishDelay = 1;

function getTimestamp(){
    var d = new Date();
    return d.getTime();
}

function publishToBridgeDelay(element){
    var x = $(element).parent().find("[data-bridge*="+""+"]");
    var msg = $(element).parent().attr("data-bridge-publisher");
    var json = '{"topic":"'+msg+'",';
    msg +="\n";
    if(lastSend[msg]== null || (lastSend[msg]+publishDelay) < getTimestamp()){
        lastSend[msg] = getTimestamp();
        for(var i=0;i<x.length;i++){
           if(!isNaN((x[i]).value) && !isNaN(parseInt((x[i]).value))){
                json += '"'+$(x[i]).attr("data-bridge")+'":'+(x[i]).value+',';
            }else{
                json += '"'+$(x[i]).attr("data-bridge")+'":"'+(x[i]).value+'",';
            }
            msg += $(x[i]).attr("data-bridge")+" "+(x[i]).value+"\n";
        }
        json = json.substring(0, json.length - 1);
        json +="}";
        console.log(json);
        socket.emit('browserServer', json);
    }
}

function publishMessageToBridge(message){
    var json = JSON.stringify(message);
    socket.emit('browserServer', json);
}

            $(document).ready(function(){
                console.log("Socket init");
                console.log(document.domain+" "+location.port);
                socket = io.connect('http://' + document.domain + ':' + location.port + '/pubsub');
                socket.on('connect', function() {
                    socket.emit('joined', {});
                });
                socket.on('status', function(data) {
                    $('#chat').val($('#chat').val() + '<' + data.msg + '>\n');
                    $('#chat').scrollTop($('#chat')[0].scrollHeight);
                });
                socket.on('message', function(data) {
                    $('#chat').val($('#chat').val() + data.msg + '\n');
                    $('#chat').scrollTop($('#chat')[0].scrollHeight);
                    if(receiver!=null){
                        receiver.html(data.msg);
                    }
                });
                socket.on('fromServer', function(data) {
                    //console.log("FromServer: "+data);
                    inMessage = JSON.parse(data.msg);
                    var jsOut = JSON.stringify(inMessage);
                    socket.emit('jsonEcho',{msg: jsOut});
                    //inMessage = data;
                });
                socket.on('topicReceiver', function(data) {
                    inMessage = JSON.parse(data.msg);
                    //publish(inMessage);
                    publish3(inMessage);

                });
                socket.on('/himx', function(data) {
                    inMessage = JSON.parse(data.msg);
                    //publish(inMessage);
                    publish3(inMessage);

                });
                socket.on('serverBrowser', function(data) {
                    inMessage = JSON.parse(data.msg);
                    publish3(inMessage);
                    publishToMap(inMessage);
                    publishDebug(inMessage, data.msg);

                });
                $('#text').keypress(function(e) {
                    var code = e.keyCode || e.which;
                    if (code == 13) {
                        text = $('#text').val();
                        $('#text').val('');
                        socket.emit('text', {msg: text});
                    }
                });
                console.log("Socket complete");

                $("[data-bridge-publisher*="+""+"] > [data-bridge="+"publish"+"]").click(function() {
                    //publishToBridge(this);
                    publishToBridgeDelay(this);
                });

            });


$(document).ready(function(){
    registerSubscribers();
    //triggerMessage();
    triggerGamepad();
});