class Core {

    subscribe(topic, callback){
        console.log("Subscribing");
        var callbacks = this.subscribers[topic];
        if(callbacks == null){ callbacks = []; }
        callbacks.push(callback);
        this.subscribers[topic] = callbacks;
    }

    subscribeAll(callback){
        this.subscribersAll.push(callback);
    }

    publish(message){
        var json = JSON.stringify(message);
        console.log("Odesilam: "+json);
        this.socket.emit('browserServer', json)
    }

    notifySubscribers(message) {
        var topic = message.topic;
        var subs = joinArrays(this.subscribers[topic],this.subscribersAll);
        if(subs != null && subs.length == 0) { return; }
        for(var sub of subs){
            sub(message);
        }
    }

    constructor(ip, port, namespace){
        console.log(`IP: ${ip} Port: ${port} Namespace: ${namespace}`);
        this.subscribers = {};
        this.subscribersAll = [];
        this.socket = io.connect('http://' + ip + ':' + port + '/' + namespace);
        var self = this;

        this.socket.on('connect', function() {
            self.socket.emit('joined', {});
        });

        this.socket.on('status', function(data) {
            console.log(data.msg);
        });

        this.socket.on('serverBrowser', function(data) {
            var inMessage = JSON.parse(data.msg);
            self.notifySubscribers(inMessage);
        });
    }


}

var core = new Core(document.domain, location.port, "pubsub")