function publishDebug(message){
    var debug = $(".debug")
    if(debug){
        var topic = $(debug).find("[data-topic=\""+message.topic+"\"]");
        var original = JSON.stringify(message);
        if(topic.length > 0){
            var val = $(topic).find(".counter");
            $(val).text(parseInt(val.text(),10)+1);
            $(topic).find(".content").text(original);
        }else{
            $("<div class=\"d-inline-block\" data-topic="+message.topic+"><p class=\"d-inline-block\">"+message.topic+"</p><p class=counter d-inline>0</p><p class=content d-inline>"+original+"</p></div>").appendTo(".debug");
        }
    }
}

function updatePage(message){
    var x = $("[data-bridge-subscriber=\""+message.topic+"\"]");
    for(var i=0;i<x.length;i++){
        for (let [key, value] of Object.entries(message)) {
           $(x[i]).find("[data-bridge="+key+"]").val(value);
        }
    }
}

function elementToMessageObject(element) {
    var output = {};
    var x = $(element).parent().find('[data-bridge!=""]');
    var msg = $(element).parent().attr("data-bridge-publisher");
    output["topic"] = msg;
    for(var i=0;i<x.length;i++){
        output[$(x[i]).attr("data-bridge")] = inputToType((x[i]).value);
    }
    return output;
}

function registerOnClickPublishers(core) {
    var elements = $('[data-bridge-publisher!=""] > [data-bridge="publish"]');
    for(var element of elements){
        $(element).click(function() {
            var message = elementToMessageObject(this);
            core.publish(message);
        });
    }
}